var map, lat, lng, route, currPosition;

$(function(){

  route = JSON.parse(localStorage.route || "[]");

  /* 
   * Funciones específicas del vector de ruta
   ***/
  function loadRoute() {
    lat = route[0][0];  // guarda coords en lat y lng
    lng = route[0][1];

    map = new GMaps({  // muestra mapa centrado en coords [lat, lng]
      el: '#map',
      lat: lat,
      lng: lng,
      click: enlazarMarcador,
      tap: enlazarMarcador
    });
    map.addMarker({ lat: lat, lng: lng});  // marcador en [lat, lng]
    //addPosition(lat, lng);

    //Pintamos nuevamente la ruta cargada. 
    for (iIndex=0; iIndex<(route.length)-1; iIndex++) {
      map.addMarker({ lat: route[iIndex][0], lng: route[iIndex][1]});
      map.drawRoute({
        origin: [route[iIndex][0], route[iIndex][1]],
        destination: [route[iIndex+1][0], route[iIndex+1][1]],
        travelMode: 'driving',
        strokeColor: '#000000',
        strokeOpacity: 0.6,
        strokeWeight: 5
      });        
    }

    //El último punto debe ser en el que estamos posicionados
    lat = route[route.length-1][0];  // guarda coords en lat y lng
    lng = route[route.length-1][1];
    map.addMarker({ lat: lat, lng: lng});
  } 

  function initRoute(position) {
    lat = position.coords.latitude;  // guarda coords en lat y lng
    lng = position.coords.longitude;

    map = new GMaps({  // muestra mapa centrado en coords [lat, lng]
      el: '#map',
      lat: lat,
      lng: lng,
      click: enlazarMarcador,
      tap: enlazarMarcador
    });
    map.addMarker({ lat: lat, lng: lng});  // marcador en [lat, lng]
    addPosition(lat, lng);
  }

  function addPosition(lat, lng) {
    route[route.length] = [lat, lng];
    localStorage.route = JSON.stringify(route);
  }

  /* 
   * Funciones genéricas de la ruta
   ***/
  function enlazarMarcador(e){

   // muestra ruta entre marcas anteriores y actuales
    map.drawRoute({
      origin: [lat, lng],  // origen en coordenadas anteriores
      // destino en coordenadas del click o toque actual
      destination: [e.latLng.lat(), e.latLng.lng()],
      travelMode: 'driving',
      strokeColor: '#000000',
      strokeOpacity: 0.6,
      strokeWeight: 5
    });

    lat = e.latLng.lat();   // guarda coords para marca siguiente
    lng = e.latLng.lng();

    map.addMarker({ lat: lat, lng: lng});  // pone marcador en mapa

    //Se modifica para realizar la carga de la ruta.
    addPosition(lat, lng);
  };

  $("#buttonInit").on('click', function(){
    route = new Array();
    localStorage.route = JSON.stringify(route);
    geolocalizar();  
  });

  $("#buttonCompact").on('click', function(){
    var latIni = route[0][0];
    var lngIni = route[0][1];
    var latFin = route[route.length-1][0];
    var lngFin = route[route.length-1][1];

    route = new Array();
    route = [[latIni, lngIni], [latFin, lngFin]];
    localStorage.route = JSON.stringify(route);
    loadRoute();  
  });

  function geolocalizar(){
    GMaps.geolocate({
      success: function(position){
        if (route.length===0) initRoute(position);
        else loadRoute();
      },
      error: function(error) { alert('Geolocalización falla: '+error.message); },
      not_supported: function(){ alert("Su navegador no soporta geolocalización"); },
    });
  };

  geolocalizar();
});
